# Vorraussetzungen

Folgendes wird in Linux gemacht (es ist aber nicht zwingend ein eigenes Linux erforderlich):

* Erstellen und bearbeiten von Dateien (Shell oder GUI)
* Starten von Programmen auf der Commandline

## Installation in Ubuntu Linux

``` bash
sudo apt install docker-compose
sudo adduser <user> docker # allow docker as user
su <user> # relogin or reboot system to apply new group
```

## Ohne Linux

### Verwenden einer virtuellen Maschine mit Linux

Z.B. mit _Virtual Box_ kann ein virtueller Rechner aufgesetzt werden.

### Verbinden über ssh auf einen Linux-Rechner

Wer kein eigenes Linux hat, kann sich über ssh mit einem Linux-Rechner verbinden, z.B. mit _Putty_. In diesem Fall ist es gut, wenn man auch Dateien auf der Commandline editieren kann.

### Verwenden von Windows Subsystem for Linux

Das geht wohl auch irgendwie, aber nicht besonders gut.

# Hello-World Projekt erstellen

## Mit git

``` bash
git clone https://git.hilie.de/toptica/docker-compose-workshop.git hello-world
cd hello-world
git checkout hello-world
```

## Ohne git

``` bash
mkdir hello-world
cd hello-world
vi docker-compose.yaml # Datei »docker-compose.yaml« erstellen und bearbeiten
```

Inhalt für docker-compose.yaml:
``` yaml
version: '3'

services:
  hello_world:
    image: hello-world:latest
```

# Hello-World Projekt ausführen
``` bash
docker-compose up
```

Folgende Ausgabe sollte unter anderem so ähnlich erscheinen:
``` bash
Recreating dockercompose_hello_world_1 ... 
Recreating dockercompose_hello_world_1 ... done
Attaching to dockercompose_hello_world_1
hello_world_1  | 
hello_world_1  | Hello from Docker!
hello_world_1  | This message shows that your installation appears to be working correctly.
hello_world_1  | 
hello_world_1  | To generate this message, Docker took the following steps:
hello_world_1  |  1. The Docker client contacted the Docker daemon.
hello_world_1  |  2. The Docker daemon pulled the "hello-world" image from the Docker Hub.
hello_world_1  |     (amd64)
hello_world_1  |  3. The Docker daemon created a new container from that image which runs the
hello_world_1  |     executable that produces the output you are currently reading.
hello_world_1  |  4. The Docker daemon streamed that output to the Docker client, which sent it
hello_world_1  |     to your terminal.
hello_world_1  | 
hello_world_1  | To try something more ambitious, you can run an Ubuntu container with:
hello_world_1  |  $ docker run -it ubuntu bash
hello_world_1  | 
hello_world_1  | Share images, automate workflows, and more with a free Docker ID:
hello_world_1  |  https://hub.docker.com/
hello_world_1  | 
hello_world_1  | For more examples and ideas, visit:
hello_world_1  |  https://docs.docker.com/get-started/
hello_world_1  | 
dockercompose_hello_world_1 exited with code 0
```
